#ifdef pl1
 globe: proc; 
#else
/*
 * $Source:$
 * $Author:$
 */
#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <math.h>
#define WINSIZ 500
#define WINBDR 50
#define WINRAD ((WINSIZ-2*WINBDR)/2)
#define WINXOF (WINBDR+WINRAD)

main() {
#endif pl1

/* This program draws the globe from any viewpoint.
   I have copied the CTSS incarnation of the program.
   */

/* This program draws the globe from any viewpoint.
   I have copied the MULTICS PL1 port of the program,
   and the data set as well.
   _Mark Eichin <eichin@athena.mit.edu> */

#ifdef pl1
dcl (i, j, k, l, m, n) fixed bin,
     nelts fixed bin,				/* gui only lets me display 4000 lines */
     toomany fixed bin int static init (1000),
     ap ptr,
     al fixed bin,
     bchr char (al) unaligned based (ap),
     ec fixed bin,
     world_ptr ptr,
     temp_ptr ptr;
#else
int i,j,k,l,m,n;
int nelts;

#endif



#ifdef pl1
dcl (fa1, fa2, fa3, fa4, fa5, fa6, fa7, fa8, fa9) float bin,
    (cosa, cosp, cost, sina, sint, sinp) float bin,
    (x0, y0, z0) float bin,
     z float bin,
     exit fixed bin init (0),
     mode fixed bin init (1),
     line fixed bin init (0),
    (ix, iy) fixed bin,
    (delx, dely) fixed bin,
    (xprev, yprev) fixed bin,
     icentr fixed bin init (0),
     jcentr fixed bin init (0),
     erase fixed bin init (0),
     TINY fixed bin init (2),
     rad float bin,
     radus float bin,
     factor float bin init (1.745329e-2),		/* pi / 180 */
     frac float bin init (0.0e0);
#else
float fa1, fa2, fa3, fa4, fa5, fa6, fa7, fa8, fa9;
float cosa, cosp, cost, sina, sint, sinp;
float x0, y0, z0;
int exit=0;
int mode=1;
int line=0;
int inform=1;
float z;
int ix, iy;
int delx, dely;
int xprev, yprev;
int icentr = (WINXOF);
int jcentr = (-WINXOF);

int TINY = (-1);			/* could be bigger? */
float rad;
float radus;
float factor = (1.745329e-2);		/* pi / 180 */
float frac =  (0.0e0);

#endif pl1

#ifdef pl1
dcl  alpha float bin init (0.0e0),
     phi float bin init (42.36058333e0),		/* Latitude of IPC 42-21-38.1 N */
     theta float bin init (288.9063333e0),		/* Longitude of IPC 71-05-35.4 W */
     irad fixed bin,
     radius float bin init (1.0e0);
#else
float alpha = (0.0e0);
float phi =  (42.36058333e0);		/* Latitude of IPC 42-21-38.1 N */
float theta =  (288.9063333e0);		/* Longitude of IPC 71-05-35.4 W */
float ialpha, iphi, itheta;
float irad;
float radius = (1.0e0);
#endif pl1

#ifdef pl1
dcl  gui_$ginit_ entry,
     gui_$gcirc_ entry (fixed bin, fixed bin),
     gui_$gvec_ entry (fixed bin, fixed bin, fixed bin),
     gui_$gsps_ entry (fixed bin, fixed bin, fixed bin),
     gui_$gdisp_ entry,
     gui_$grmv_ entry,
     gui_$geras_ entry;
#else
Display *dpy;
Window win;
unsigned long valuemask;
XSetWindowAttributes wvals;
XSizeHints	xsh;
#endif pl1

#ifdef pl1
dcl 1 worldbin based (world_ptr) aligned,
    2 input (0:6048) fixed bin;

dcl  temp fixed bin;

dcl 1 component based (temp_ptr) aligned,
    2 x fixed bin (11) unal,
    2 y fixed bin (11) unal,
    2 z fixed bin (11) unal;
#else
FILE *world_ptr;
typedef struct component {
  int x, y, z;
} component;

component input[6050];

#endif pl1


#ifdef pl1
dcl (addr, sin, cos, abs, null) builtin;
dcl  name condition;
dcl  sysin file;

dcl  cu_$arg_ptr ext entry (fixed bin, ptr, fixed bin, fixed bin),
     hcs_$make_ptr entry (ptr, char (*) aligned, char (*) aligned, ptr, fixed bin),
     ioa_ ext entry options (variable),
     com_err_ ext entry options (variable),
     hcs_$terminate_noname ext entry (ptr, fixed bin);
#else
#endif pl1

/* =============================================== */
#ifdef pl1
	temp_ptr = addr (temp);
	call hcs_$make_ptr (null, "world.bin", "", world_ptr, ec);
	if world_ptr = null then do;
er:	     call com_err_ (ec, "globe", "world.bin");
	     return;
	end;
#else

world_ptr = fopen("world.bin", "r");
i=1;
while(fscanf(world_ptr,"%d %d %d", &input[i].x, &input[i].y, &input[i].z)!=EOF)
  i++;
#endif

#ifdef pl1
	call gui_$ginit_;
#else
dpy = XOpenDisplay(NULL);
xsh.flags = (PPosition|PSize);
xsh.height = WINSIZ;
xsh.width = WINSIZ;
xsh.x = (DisplayWidth(dpy, DefaultScreen(dpy)) - xsh.width)/2;
xsh.y = (DisplayHeight(dpy, DefaultScreen(dpy)) - xsh.height)/2;
/*
 * Create the Window
 *
 * By default the foreground for a window is White so we set the background
 * to Black here.
 */
    win = XCreateSimpleWindow(dpy, DefaultRootWindow(dpy),
		xsh.x, xsh.y, xsh.width, xsh.height,
		1, WhitePixel(dpy, DefaultScreen(dpy)),
		BlackPixel(dpy, DefaultScreen(dpy)));

wvals.override_redirect = False;
wvals.background_pixel = 0;
valuemask = CWBackPixel | CWOverrideRedirect;
XChangeWindowAttributes(dpy, win, valuemask, &wvals);
/* XSetForeground(dpy, DefaultGC(dpy,0), 1); */

XMapWindow(dpy, win);
XClearWindow(dpy, win);
XFlush(dpy);
#endif pl1

#ifdef pl1
inform:	mode = 1;
	call ioa_ ("The following is an example of a complete input line:");
	call ioa_ (" phi = ^f, theta = ^f, alpha = ^f, radius = ^f;", phi, theta, alpha, radius);
	call ioa_ ("(phi and theta are latitude and longitude of the display center, and");
	call ioa_ (" alpha is rotation around the center. Radius 1.0 is full screen.)");
	call ioa_ ("To find the values of parameters, type:");
	call ioa_ (" mode = 0;");
	call ioa_ ("To exit from the program, type:");
	call ioa_ (" exit = 1;");

start:	call ioa_ ("^/Enter input data");
	on name (sysin) begin;
	     call ioa_ ("Illegal input.");
	     go to inform;
	end;

	get data (phi, theta, alpha, radius, mode, exit);
#else
theta = 0;
while(!exit)
  {
    int spin=1;
    XFlush(dpy);
    mode = 1;
    inform=0;
    if(inform)
      {
	printf ("The following is an example of a complete input line:\n");
	printf (" phi = %f, theta = %f, alpha = %f, radius = %f;\n", phi, theta, alpha, radius);
	printf ("(phi and theta are latitude and longitude of the display center, and\n");
	printf (" alpha is rotation around the center. Radius 1.0 is full screen.)\n");
/*	printf ("To find the values of parameters, type:\n");
	printf (" mode = 0;\n"); */
	printf ("To exit from the program, type:\n");
	printf (" -2 -2 -2\n");
	inform = 0;
      }
    if(!spin) {
      printf("Enter phi, theta, alpha (-1.0 to leave unchanged):");
      scanf("%f %f %f", &iphi, &itheta, &ialpha);
      if (iphi != -1.0) phi = iphi;
      if (itheta != -1.0) theta = itheta;
      if (ialpha != -1.0) alpha = ialpha;
    } else {
      phi = 0.0;
      theta += 5.0 ;
      alpha = 0.0;
    }
#endif pl1

#ifdef pl1

	if exit = 1 then do;
	     call hcs_$terminate_noname (world_ptr, ec);
	     return;
	end;
	if mode = 0 then go to inform;
	if erase = 0 then call gui_$geras_;
#else
    if (iphi == -2.0 && itheta == -2.0 && ialpha == -2.0)
      {
	fclose(world_ptr);
	return;
      }
#endif pl1

#ifdef pl1
	if phi < 0 then phi = 360.0e0 - phi;
	if theta < 0 then theta = 360.0e0 - theta;
#else
	if (phi < 0)  phi = 360.0e0 - phi;
	if (theta < 0) theta = 360.0e0 - theta;
#endif pl1


	sinp = sin (phi * factor);
	cosp = cos (phi * factor);
	sint = sin (theta * factor);
	cost = cos (theta * factor);
	sina = sin (alpha * factor);
	cosa = cos (alpha * factor);

	fa1 = cost * cosa + sinp * sina * sint;
	fa2 = -cosp * sina;
	fa3 = cost * sina * sinp - sint * cosa;
	fa4 = cost * sina - sint * cosa * sinp;
	fa5 = cosp * cosa;
	fa6 = -cost * cosa * sinp - sint * sina;
	fa7 = sint * cosp;
	fa8 = sinp;
	fa9 = cost * cosp;
	radus = radius * (float)WINRAD;	/* 512.e0; */
	irad = radus + 0.5e0;
	line = 0;
	rad = radus;

#ifdef pl1
	call gui_$gsps_ (0, irad, 0);
	call gui_$gcirc_ (0, -irad);

	call gui_$gdisp_;				/* Display the circle */
	call gui_$grmv_;				/* Empty the display list */
#else
XFlush(dpy);
XClearWindow(dpy, win);
XDrawArc(dpy, win, DefaultGC(dpy,0),
	 WINBDR, WINBDR,
	 2*WINRAD, 2*WINRAD,
	 0, 360*64);
#endif pl1

	nelts = 0;
#ifdef pl1
	do i = 6048 to 1 by -1;

	     if input (i) = -1 then go to done;
	     if input (i) = 0 then go to linend;

	     temp = input (i);

	     z0 = component.z / 1.e3 - 1.0e0;
	     y0 = component.y / 1.e3 - 1.0e0;
	     x0 = component.x / 1.e3 - 1.0e0;

	     z = fa7 * x0 + fa8 * y0 + fa9 * z0;
	     if z < frac then go to linend;

	     if mode ^= 2 then go to ster;
	     rad = radus / (z + 1.0e0);

ster:	     

	     ix = rad * (fa1 * x0 + fa2 * y0 + fa3 * z0);
	     iy = rad * (fa4 * x0 + fa5 * y0 + fa6 * z0);
	     ix = ix + icentr;
	     iy = iy + jcentr;


	     if abs (ix) > 1.e3 then go to linend;
	     if abs (iy) > 1.e3 then go to linend;

	     if line = 0 then go to newlin;

	     delx = ix - xprev;
	     dely = iy - yprev;


	     if abs (delx) < TINY then if abs (dely) < TINY then go to loop;

	     line = line + 1;

	     call gui_$gvec_ (delx, dely, 0);
	     nelts = nelts + 1;
	     go to more;

newlin:	     call gui_$gsps_ (ix, iy, 0);
	     nelts = nelts + 1;

	     line = 1;

more:	     xprev = ix;
	     yprev = iy;

	     go to loop;

linend:	     if line = 1 then do;
		call gui_$gvec_ (1, 1, 0);
		nelts = nelts + 1;
	     end;
	     if nelts > toomany then do;
		call gui_$gdisp_;
		call gui_$grmv_;
		nelts = 0;
	     end;

	     line = 0;

loop:	end;

done:	call gui_$gsps_ (0, 512, 0);
	call gui_$gdisp_;

	call gui_$grmv_;

	go to start;

     end globe;


#else
    for(i=6048;i>=1;i--)
      {
	if((input[i].x == -1) && (input[i].y == -1) && (input[i].z == -1))
	  continue;

	while((input[i].x != 0) || (input[i].y != 0) || (input[i].z != 0))
	  {
	     z0 = input[i].z / 1.e3 - 1.0e0;
	     y0 = input[i].y / 1.e3 - 1.0e0;
	     x0 = input[i].x / 1.e3 - 1.0e0;
	     z = fa7 * x0 + fa8 * y0 + fa9 * z0;
	     if (z < frac) break;

	     if (mode == 2)
	       rad = radus / (z + 1.0e0);

	     ix = rad * (fa1 * x0 + fa2 * y0 + fa3 * z0);
	     iy = rad * (fa4 * x0 + fa5 * y0 + fa6 * z0);

	     if (abs(ix) >= WINRAD || abs(iy) >= WINRAD)
	       break;

	     ix = ix + icentr;
	     iy = iy + jcentr;

	     delx = ix - xprev;
	     dely = iy - yprev;

	     if (abs (delx) >= TINY && abs (dely) >= TINY)
	       {
		 if(line) 
		   {
		     XDrawLine(dpy, win, DefaultGC(dpy, 0),
			       xprev, -yprev,
			       ix, -iy);
		     
		   }
	       }
	     line = line + 1;

	     xprev = ix;
	     yprev = iy;
	     i--;
	   }
	line = 0;
      }
  }
}

#endif
